diff -urN versao_6D/stoqdrivers-0.9.11/stoqdrivers/printers/bematech/MP25.py trunk/stoqdrivers/printers/bematech/MP25.py
--- versao_6D/stoqdrivers-0.9.11/stoqdrivers/printers/bematech/MP25.py	2016-12-29 14:30:59.000000000 -0200
+++ trunk/stoqdrivers/printers/bematech/MP25.py	2017-01-23 16:54:44.669415181 -0200
@@ -1,4 +1,4 @@
-# -*- Mode: Python; coding: iso-8859-1 -*-
+# -*- Mode: Python; coding: utf-8 -*-
 # vi:si:et:sw=4:sts=4:ts=4
 
 ##
@@ -29,32 +29,31 @@
 """
 Bematech MP25 driver
 """
-
-import datetime
+import re
+import binascii
 from decimal import Decimal
-import struct
-
+from docutils.nodes import description
 from kiwi.datatypes import currency
-from kiwi.log import Logger
+from stoqdrivers.logs.log import traced as log
 from kiwi.python import Settable
-from zope.interface import implements
-
-from stoqdrivers.serialbase import SerialBase
-from stoqdrivers.exceptions import (DriverError, OutofPaperError, PrinterError,
-                                    CommandError, CouponOpenError,
-                                    HardwareFailure,
-                                    PrinterOfflineError, PaymentAdditionError,
-                                    ItemAdditionError, CancelItemError,
-                                    CouponTotalizeError, CouponNotOpenError)
+from stoqdrivers.enum import TaxType, UnitType
+from stoqdrivers.exceptions import DriverError, OutofPaperError, PrinterError, \
+    CommandError, CouponOpenError, HardwareFailure, PrinterOfflineError, CodigoInvalido, \
+    PaymentAdditionError, ItemAdditionError, CancelItemError, CouponTotalizeError, \
+    CouponNotOpenError, AlmostOutofPaper, BlockZ, PendingReduceZ, PrinterHeadUp, AuthenticationFailure
 from stoqdrivers.interfaces import ICouponPrinter
-from stoqdrivers.printers.capabilities import Capability
 from stoqdrivers.printers.base import BaseDriverConstants
-from stoqdrivers.enum import TaxType, UnitType
+from stoqdrivers.printers.capabilities import Capability
+from stoqdrivers.serialbase import SerialBase
 from stoqdrivers.translation import stoqdrivers_gettext
+from zope.interface import implements
+import datetime
+import struct
+
+
 
 _ = stoqdrivers_gettext
 
-log = Logger('stoqdrivers.bematech.MP25')
 
 CASH_IN_TYPE = "SU"
 CASH_OUT_TYPE = "SA"
@@ -67,13 +66,18 @@
 CMD_READ_X = 6
 CMD_READ_MEMORY = 8
 CMD_COUPON_CANCEL = 14 # MP25 aceita 3 parametros opicionais
+CMD_SUMMER_TIME = 18 # Horário de Verão
 CMD_STATUS = 19
+CMD_OPEN_TILL = 22 # Abrir Gaveta
 CMD_ADD_VOUCHER = 25
 CMD_READ_TAXCODES = 26
-CMD_READ_TOTALIZERS = 27
+CMD_READ_TOTALIZERS_PARCIAL = 27 # tot. parciais nao completos
+CMD_READ_TOTALIZERS = 87 # totalizadores parciais completos
+CMD_READ_LAST_REDUCE = 88
 CMD_GET_COUPON_SUBTOTAL = 29
 CMD_GET_COUPON_NUMBER = 30
-CMD_CANCEL_ITEM = 31
+CMD_CANCEL_LAS_ITEM = 13 # cancela o ultimo item
+CMD_CANCEL_ITEM = 31 # cancela um item especifico
 CMD_COUPON_TOTALIZE = 32 # MP 20 Nao permite desconto simultaneo
 CMD_COUPON_CLOSE = 34
 CMD_READ_REGISTER = 35 # Registradores diferentes
@@ -81,59 +85,97 @@
 CMD_PAYMENT_RECEIPT_OPEN = 66 # MP20 suporta somente 3 primeiro parametros
 CMD_PAYMENT_RECEIPT_PRINT = 67
 CMD_PAYMENT_RECEIPT_CLOSE = 21 # Parece o mesmo, mas com nomes diferentes na mp20 e 25
+CMD_GERENCIAL_REPORT_OPEN = 83
+CMD_GERENCIAL_REPORT_PRINT = 67
+CMD_GERENCIAL_REPORT_CLOSE = 21
+CMD_DISCOUNT_SURCHARGE_AFTER = 93 # Desconto/Acresciomo para o item no final do cupom
+
 CMD_PROGRAM_PAYMENT_METHOD = 71
 CMD_ADD_PAYMENT = 72
+
 # Be carefull with these commands, They are only available for MP25 (not mp20)
 CMD_CANCEL_LAST = 81
 CMD_PAYMENT_RECEIPT_PRINT_DUPLICATE = 91
 
-
 NAK = 21
 ACK = 6
 STX = 2
 
-RETRIES_BEFORE_TIMEOUT = 5
+RETRIES_BEFORE_TIMEOUT = 10
+
+TWOPLACES = Decimal(10) ** -2
+TREPLACES = Decimal(10) ** -3
 
 # Page 51
+def isbitset(value, bit):
+    # BCD crap
+    return (int(value, 16) >> bit) & 1 == 1
+
 class MP25Registers(object):
     TOTAL = 3
     TOTAL_CANCELATIONS = 4
     TOTAL_DISCOUNT = 5
+    TOTAL_TESTE = 11
     COO = 6
+    COO_INICIAL_FINAL = 72
     GNF = 7
+    CFC = 8
     NUMBER_REDUCTIONS_Z = 9
     CRO = 10
     LAST_ITEM_ID = 12
+    CLICHE = 64
     NUMBER_TILL = 14
+    READ_LOJA = 15
+    FISCAL_FLAGS = 17
     EMISSION_DATE = 23
+    DATE_LAST_RZ = 26
+    MOV_DATE = 27
     TRUNC_FLAG = 28
     TOTALIZERS = 29
     PAYMENT_METHODS = 32
     SERIAL = 40
     FIRMWARE = 41
+    READ_IE = 43
+    CDC = 52
+    GRG = 54
     CCF = 55
+    DATE_MOV_LAST_RZ = 67
+    GT = 73
 
     # (size, bcd)
     formats = {
         TOTAL: ('9s', True),
         TOTAL_CANCELATIONS: ('7s', True),
         TOTAL_DISCOUNT: ('7s', True),
+        TOTAL_TESTE: ('7s', True),
         COO: ('3s', True),
+        COO_INICIAL_FINAL: ('6s', True),
+        READ_IE: ('20s', False),
+        READ_LOJA: ('2s', True),
         GNF: ('3s', True),
+        CFC: ('2s', True),
+        CDC: ('2s', True),
+        GRG: ('3s', True),
         NUMBER_REDUCTIONS_Z: ('2s', True),
         CRO: ('2s', True),
         LAST_ITEM_ID: ('2s', True),
         NUMBER_TILL: ('2s', True),
-        EMISSION_DATE: ('6s', False),
+        FISCAL_FLAGS: ('1s', False),
+        EMISSION_DATE: ('6s', True),
+        DATE_LAST_RZ: ('6s', True),
+        MOV_DATE: ('3s', True),
         TRUNC_FLAG: ('1s', False),
         TOTALIZERS: ('2s', False),
+        CLICHE: ('6s', False),
         #  1 + (52 * 16) + (52 * 10) + (52 * 10) + (52 * 1)
         #  1 + 832 + 520 + 520 + 52: 1925
         PAYMENT_METHODS: ('b832s520s520s52s', False),
         SERIAL: ('20s', False),
         FIRMWARE: ('3s', True),
         CCF: ('3s', True),
-    }
+        DATE_MOV_LAST_RZ: ('3s', True),
+        GT: ('18s', True),
+        }
 
 
 class MP25Constants(BaseDriverConstants):
@@ -147,20 +189,20 @@
 
 class MP25Status(object):
     st1_codes = {
-        128: (OutofPaperError(_("Printer is out of paper"))),
-        # 64: (AlmostOutofPaper(_("Printer almost out of paper"))),
+        128: (OutofPaperError(_("Impressora sem papel"))),
+#        64: (AlmostOutofPaper(_("Impressora com pouco papel"))),
         32: (PrinterError(_("Printer clock error"))),
         16: (PrinterError(_("Printer in error state"))),
         8: (CommandError(_("First data value in CMD is not ESC (1BH)"))),
         4: (CommandError(_("Nonexistent command"))),
-        # 2: (CouponOpenError(_("Printer has a coupon currently open"))),
+        2: (CouponOpenError(_("Impressora tem um cupom aberto atualmente"))),
         1: (CommandError(_("Invalid number of parameters")))}
 
     st2_codes = {
         128: (CommandError(_("Invalid CMD parameter"))),
         64: (HardwareFailure(_("Fiscal memory is full"))),
         32: (HardwareFailure(_("Error in CMOS memory"))),
-        16: (PrinterError(_("Given tax is not programmed on the printer"))),
+        16: (PrinterError("Alíquota não programada")),
         8: (DriverError(_("No available tax slot"))),
         4: (CancelItemError(_("The item wasn't added in the coupon or can't "
                               "be cancelled"))),
@@ -168,66 +210,271 @@
         # 2: (PrinterError(_("Owner data (CGC/IE) not programmed on the printer"))),
         # FIXME: This shouldn't be commented. But it will break the tests.
         # Need to update the tests for all bematech printers
-        #1: (CommandError(_("Command not executed")))
+        1: (CommandError("Comando nao executado"))
         }
 
     st3_codes = {
-        # 7: (CouponOpenError(_("Coupon already Open"))),
-        # 8: (CouponNotOpenError(_("Coupon is closed"))),
-        13: (PrinterOfflineError(_("Printer is offline"))),
-        16: (DriverError(_("Surcharge or discount greater than coupon total"
-                           "value"))),
-        17: (DriverError(_("Coupon with no items"))),
-        20: (PaymentAdditionError(_("Payment method not recognized"))),
-        22: (PaymentAdditionError(_("Isn't possible add more payments since"
-                                     "the coupon total value already was "
-                                    "reached"))),
-        23: (DriverError(_("Coupon isn't totalized yet"))),
-        43: (CouponNotOpenError(_("Printer not initialized"))),
-        45: (PrinterError(_("Printer without serial number"))),
-        52: (DriverError(_("Invalid start date"))),
-        53: (DriverError(_("Invalid final date"))),
-        85: (DriverError(_("Sale with null value"))),
-        91: (ItemAdditionError(_("Surcharge or discount greater than item"
-                                 "value"))),
-        100: (DriverError(_("Invalid date"))),
-        115: (CancelItemError(_("Item doesn't exists or already was cancelled"))),
-        118: (DriverError(_("Surcharge greater than item value"))),
-        119: (DriverError(_("Discount greater than item value"))),
-        129: (CouponOpenError(_("Invalid month"))),
-        169: (CouponTotalizeError(_("Coupon already totalized"))),
-        170: (PaymentAdditionError(_("Coupon not totalized yet"))),
-        171: (DriverError(_("Surcharge on subtotal already effected"))),
-        172: (DriverError(_("Discount on subtotal already effected"))),
-        176: (DriverError(_("Invalid date")))}
+         #0: Comando ok
+         #1 Comando inválido
+         #2 Erro desconhecido
+         #3 Número de parâmetro inválido
+         #4 Tipo de parâmetro inválido
+         #5 Todas alíquotas já programadas
+         #6 Totalizador não fiscal já programado
+         #7 Cupom fiscal aberto
+         #8 Cupom fiscal fechado
+         #9 ECF ocupado
+         #0 Impressora em erro
+         11: (DriverError("Impressora sem papel")),
+         12: (PrinterHeadUp("Impressora com cabeça levantada")),
+         13: (PrinterOfflineError("Impressora OFF LINE")),
+         14: (DriverError("Alíquota não programada")),
+         15: (DriverError("Terminador de string faltando")),
+         16: (DriverError("Acréscimo ou desconto maior que o total do cupom fiscal")),
+         17: (DriverError("Cupom fiscal sem item vendido")),
+         18: (DriverError("Comando nao efetivado")),
+         19: (DriverError("Sem espaço para novas formas de pagamento")),
+         20: (PaymentAdditionError("Forma de pagamento não programada")),
+         21: (PaymentAdditionError("Índice maior que número de forma de pagamento")),
+         22: (DriverError("Formas de pagamento encerradas")),
+         23: (DriverError("Cupom não totalizado")),
+         24: (DriverError("Comando maior que 7F")),
+         25: (DriverError("Cupom fiscal aberto e sem item")),
+         26: (DriverError("Cancelamento não imediatamento após")),
+         27: (DriverError("Cancelamento já efetuado")),
+         28: (DriverError("Comprovante de crédito ou débito não permitido ou já emitido")),
+         29: (DriverError("Meio de pagamento não permite TEF")),
+         30: (DriverError("Sem comprovante não fiscal aberto")),
+         31: (DriverError("Comprovante de crédito ou débito já aberto")),
+         32: (DriverError("Reimpressão não permitida")),
+         33: (DriverError("Comprovante não fiscal já aberto")),
+         34: (DriverError("Totalizador não fiscal não programado")),
+         35: (DriverError("Cupom não fiscal sem item vendido")),
+         36: (DriverError("Acréscimo e desconto maior que total CNF")),
+         37: (DriverError("Meio de pagamento não indicado")),
+         38: (DriverError("Meio de pagamento diferente do total de recebimento")),
+         39: (DriverError("Não permitido mais de uma sangria ou suprimento")),
+         40: (DriverError("Relatório já programado")),
+         41: (DriverError("Relatório gerencial não programado")),
+         42: (DriverError("Relatório gerencial não permitido")),
+         43: (CouponNotOpenError("MFD não inicializada")),
+         44: (DriverError("MFD ausente")),
+         45: (DriverError("MFD sem número de série")),
+         46: (DriverError("MFD já inicializada")),
+         47: (DriverError("MFD lotada")),
+         48: (DriverError("Cupom não fiscal aberto")),
+         49: (DriverError("Memória fiscal desconectada")),
+         50: (DriverError("Memória fiscal sem número de série da MFD")),
+         51: (DriverError("Memória fiscal lotada")),
+         52: (DriverError("Data inicial inválida")),
+         53: (DriverError("Data final inválida")),
+         54: (DriverError("Contador de Redução Z inicial inválido")),
+         55: (DriverError("Contador de Redução Z final inválido")),
+         56: (DriverError("Erro de alocação")),
+         57: (DriverError("Dados do RTC incorretos")),
+         58: (DriverError("Data anterior ao último documento emitido")),
+         59: (DriverError("Fora de intervenção técnica")),
+         60: (DriverError("Em intervenção técnica")),
+         61: (DriverError("Erro na memória de trabalho")),
+         #62: (DriverError("Já houve movimento no dia")),
+         63: (BlockZ("Bloqueio por RZ")),
+         64: (DriverError("Forma de pagamento aberta")),
+         65: (DriverError("Aguardando primeiro proprietário")),
+         66: (DriverError("Aguardando RZ")),
+         67: (DriverError("ECF ou loja igual a zero")),
+         68: (DriverError("Cupom adicional não permitido")),
+         69: (DriverError("Desconto maior que total vendido em ICMS")),
+         70: (DriverError("Recebimento não fiscal nulo não permitido")),
+         71: (DriverError("Acréscimo ou desconto maior que total não fiscal")),
+         72: (DriverError("Memória fiscal lotada para novo cartucho")),
+         73: (DriverError("Erro de gravação na MF")),
+         74: (DriverError("Erro de gravação na MFD")),
+         75: (DriverError("Dados do RTC anteriores ao último documento armazenado")),
+         76: (DriverError("Memória fiscal sem espaço para gravar leituras da MFD")),
+         77: (DriverError("Memória fiscal sem espaço para gravar versão do SB")),
+         78: (DriverError("Descrição igual a default não permitido")),
+         79: (DriverError("Extrapolado número de repetições permitidas")),
+         80: (DriverError("Segunda via do comprovante de crédito ou débito não permitido")),
+         81: (DriverError("Parcelamento fora da sequência")),
+         82: (DriverError("Comprovante de crédito ou débito aberto")),
+         83: (DriverError("Texto com sequência de ESC inválida")),
+         84: (DriverError("Texto com sequência de ESC incompleta")),
+         85: (DriverError("Venda com valor nulo")),
+         86: (DriverError("Estorno de valor nulo")),
+         87: (DriverError("Forma de pagamento diferente do total da sangria")),
+         88: (DriverError("Redução não permitida em intervenção técnica")),
+         89: (DriverError("Aguardando RZ para entrada em intervenção técnica")),
+         90: (DriverError("Forma de pagamento com valor nulo não permitido")),
+         91: (ItemAdditionError("Acréscimo ou desconto maior que valor do ítem")),
+         92: (DriverError("Autenticação não permitida")),
+         93: (DriverError("Timeout na validação")),
+         94: (DriverError("Comando não executado em impressora bilhete de passagem")),
+         95: (DriverError("Comando não executado em impressora de Cupom Fiscal")),
+         96: (DriverError("Cupom Não Fiscal fechado")),
+         97: (DriverError("Parâmetro não ASCII em campo ASCII")),
+         98: (DriverError("Parâmetro não ASCII num em campo ASCII num")),
+         99: (DriverError("Tipo de transporte inválido")),
+         100: (DriverError("Data e hora inválida")),
+         101: (CodigoInvalido("Sem relatório gerencial")),
+         102: (DriverError("Número do totalizador não fiscal inválido")),
+         103: (DriverError("Parâmetro de acréscimo ou desconto inválido")),
+         104: (DriverError("Acréscimo ou desconto em sangria ou suprimento não permitido")),
+         105: (DriverError("Número do relatório gerencial inválido")),
+         106: (DriverError("Forma de pagamento fonte não programada")),
+         107: (DriverError("Forma de pagamento destino não programada")),
+         108: (DriverError("Estorno maior que forma pagamento")),
+         109: (DriverError("Caracter numérico na codificação GT não permitido")),
+         110: (DriverError("Erro na inicialização da MF")),
+         111: (DriverError("Nome do totalizador em branco não permitido")),
+         112: (DriverError("Data e hora anteriores ao último doc armazenado")),
+         113: (DriverError("Parâmetro de acréscimo ou desconto inválido")),
+         114: (DriverError("Item anterior aos trezentos últimos")),
+         115: (CancelItemError("Item não existe ou já cancelado")),
+         116: (DriverError("Código com espaços não permitido")),
+         117: (DriverError("Descrição sem caracter alfabético não permitido")),
+         118: (DriverError("Acréscimo maior que valor do item")),
+         119: (DriverError("Desconto maior que valor do item")),
+         120: (DriverError("Desconto em ISS não permitido")),
+         121: (DriverError("Acréscimo em item já efetuado")),
+         122: (DriverError("Desconto em item já efetuado")),
+         123: (DriverError("Erro na Memória Fiscal chamar credenciado")),
+         124: (DriverError("Aguardando gravação na Memória Fiscal")),
+         125: (DriverError("Caracter repetido na codificação do GT")),
+         126: (DriverError("Versão já gravada na memória fiscal")),
+         127: (DriverError("Estouro de capacidade no cheque (não utilizado neste modelo)")),
+         128: (DriverError("Timeout na leitura do cheque (não utilizado neste modelo)")),
+         129: (CouponOpenError("Mês inválido (não utilizado neste modelo)")),
+         130: (DriverError("Coordenada inválida (não utilizado neste modelo)")),
+         131: (DriverError("Sobreposição de texto (não utilizado neste modelo)")),
+         132: (DriverError("Sobreposição de texto no valor (não utilizado neste modelo)")),
+         133: (DriverError("Sobreposição de texto no extenso (não utilizado neste modelo)")),
+         134: (DriverError("Sobreposição de texto no favorecido (não utilizado neste modelo)")),
+         135: (DriverError("Sobreposição de texto na localidade (não utilizado neste modelo)")),
+         136: (DriverError("Sobreposição de texto no opcional (não utilizado neste modelo)")),
+         137: (DriverError("Sobreposição de texto no dia (não utilizado neste modelo)")),
+         138: (DriverError("Sobreposição de texto no mês (não utilizado neste modelo)")),
+         139: (DriverError("Sobreposição de texto no ano (não utilizado neste modelo)")),
+         140: (DriverError("Usando MFD de outro ECF")),
+         141: (DriverError("Primeiro dado diferente de esc ou 1C")),
+         142: (DriverError("Não permitido alterar sem intervenção técnica")),
+         143: (DriverError("Dados da última RZ corrompidos")),
+         144: (DriverError("Comando não permitido no modo inicialização")),
+         145: (DriverError("Aguardando acerto de relógio")),
+         146: (DriverError("MFD já inicializada para outra memoria fiscal")),
+         147: (DriverError("Aguardando acerto do relógio ou desbloqueio pelo teclado")),
+         148: (DriverError("Valor forma de pagamento maior que máximo permitido")),
+         149: (DriverError("Razão social em branco")),
+         150: (DriverError("Nome de fantasia em branco")),
+         151: (DriverError("Endereço em branco")),
+         152: (DriverError("Estorno de CDC não permitido")),
+         153: (DriverError("Dados do proprietário iguais ao atual")),
+         154: (DriverError("Estorno de forma de pagamento não permitido")),
+         155: (DriverError("Descricao forma de pagamento igual já programada")),
+         156: (DriverError("Acerto de horário de verão só imediatamente após Redução Z")),
+         157: (DriverError("Intervenção técnica não permitida MF reservada para Redução Z")),
+         158: (DriverError("Senha CNPJ inválida")),
+         159: (DriverError("Timeout na inicialização de nova MF")),
+         160: (DriverError("Dados da MFD não encontrados")),
+         161: (DriverError("Sangria ou Suprimento devem ser únicos no comprovante não fiscal")),
+         162: (CodigoInvalido("Índice da forma de pagamento nulo não permitido")),
+         163: (DriverError("UF de destino inválida")),
+         164: (DriverError("Tipo de transporte incompatível com a UF de destino")),
+         165: (DriverError("Descrição do primeiro item do Bilhete de passagem diferente de “TARIFA”")),
+         166: (DriverError("Aguardando impressão de cheque ou autenticação (não utilizado neste modelo)")),
+         167: (DriverError("Programação de CNPJ e IE preenchido com espaços em branco não permitido")),
+         168: (DriverError("Programação de UF preenchido com espaços em branco não permitido")),
+         169: (DriverError("Número de impressões da fita detalhe nesta intervenção técnica esgotado")),
+         170: (PaymentAdditionError("Cupom fiscal já sub-totalizado")),
+         171: (PaymentAdditionError("Cupom não sub-totalizado")),
+         172: (PaymentAdditionError("Acréscimo em sub-total já efetuado")),
+         173: (PaymentAdditionError("Desconto em sub-total já efetuado")),
+         174: (PaymentAdditionError("Acréscimo com valor nulo não permitido")),
+         175: (PaymentAdditionError("Desconto com valor nulo não permitido")),
+         176: (PaymentAdditionError("Cancelamento de acréscimo ou desconto em sub-total não permitido")),
+         177: (DriverError("Data inválida")),
+         178: (DriverError("Valor do cheque nulo não permitido (não utilizado neste modelo)")),
+         179: (DriverError("Valor do cheque inválido (não utilizado neste modelo)")),
+         180: (DriverError("Cheque sem a informação da localidade não permitido (não utilizado neste modelo)")),
+         181: (DriverError("Cancelamento de acréscimo em item não permitido")),
+         182: (DriverError("Cancelamento de desconto em item não permitido")),
+         183: (DriverError("Número máximo de itens atingido")),
+         184: (DriverError("Número do item nulo não permitido")),
+         185: (DriverError("Mais que duas alíquotas diferentes no Bilhete de Passagem não permitido")),
+         186: (DriverError("Acréscimo ou Desconto em item não permitido")),
+         187: (DriverError("Cancelamento de acréscimo ou desconto em item não permitido")),
+         188: (DriverError("Clichê já impresso")),
+         189: (DriverError("Texto opcional do cheque excedeu o máximo de linhas permitido (não utilizado neste modelo)")),
+         190: (DriverError("Impressão automática no verso não disponível neste equipamento")),
+         191: (DriverError("Timeout na inserção do cheque (não utilizado neste modelo)")),
+         192: (DriverError("Overflow na capacidade de texto do comprovante de débito ou crédito")),
+         193: (DriverError("Programação de espaços entre cupons menor que o mínimo permitido")),
+         194: (DriverError("Equipamento não possui leitor de cheque (não utilizado neste modelo)")),
+         195: (DriverError("Programação de alíquota com valor nulo não permitido")),
+         196: (DriverError("Parâmetro baud rate inválido")),
+         197: (DriverError("Configuração permitida somente pela porta do fisco")),
+         198: (DriverError("Valor total do item excede 11 dígitos")),
+         199: (DriverError("Programação da moeda com espaços em branco não permitido")),
+         200: (DriverError("Casa decimais devem ser programadas com 2 ou 3")),
+         201: (DriverError("Não permite cadastrar usuários diferentes na mesma MFD")),
+         202: (DriverError("Identificação do consumidor não permitido para sangria ou suprimento")),
+         203: (DriverError("Casas decimais em quantidade maior do que a permitida")),
+         204: (DriverError("Casas decimais do unitário maior do que o permitido")),
+         205: (DriverError("Posição reservada para ICMS")),
+         206: (DriverError("Posição reservada para ISS")),
+         207: (DriverError("Todas as alíquotas com a mesma vinculação não permitido")),
+         208: (DriverError("Data de embarque anterior a data de emissão")),
+         209: (DriverError("Alíquota para ISSQN não permitida sem inicialização da Inscrição Municipal")),
+         210: (DriverError("Pacote do clichê gráfico fora da seqüência")),
+         211: (DriverError("Espaço para armazenamento do clichê gráfico esgotado")),
+         212: (DriverError("Clichê gráfico não disponível para confirmação")),
+         213: (DriverError("CRC do clichê gráfico diferente do informado")),
+         214: (DriverError("Intervalo inválido")),
+         215: (DriverError("Usuário já programado")),
+         217: (DriverError("Detectada abertura do equipamento"))
+        }
 
     def __init__(self, reply):
         self.st1, self.st2, self.st3 = reply[-3:]
 
+
     @property
     def open(self):
-        return self.st1 & 2
+        return bool(self.st1 == 2)
+    @property
+    def pagamento_existe(self):
+        return bool(self.st1 == 66)
+    @property
+    def out_paper(self):
+        return self.st1 == 64
+    @property
+    def block_z(self):
+        return self.st3 == 66
+
+    @property
+    def off_line(self):
+        return self.st3 == 13
 
     def _check_error_in_dict(self, error_codes, value):
         for key in error_codes:
             if key & value:
+                # st3 eh o detalhamento de erro do st1 ou st2
+                if self.st3 in self.st3_codes:
+                    raise self.st3_codes[self.st3]
+
                 raise error_codes[key]
 
     def check_error(self):
-        log.debug("status: st1=%s st2=%s st3=%s" %
-                    (self.st1, self.st2, self.st3))
-
+#        print "status: st1=%s st2=%s st3=%s" % (self.st1, self.st2, self.st3)
+        log.debug("status: st1=%s st2=%s st3=%s" % (self.st1, self.st2, self.st3))
         if self.st1 != 0:
             self._check_error_in_dict(self.st1_codes, self.st1)
 
         if self.st2 != 0:
             self._check_error_in_dict(self.st2_codes, self.st2)
 
-            # first bit means not executed, look in st3 for more
-            if self.st2 & 1 and self.st3:
-                if self.st3 in self.st3_codes:
-                    raise self.st3_codes[self.st3]
-
+    def check_error_two(self):
+        if self.st1 not in [0, 64]:
+            self.check_error()
 
 #
 # Helper functions
@@ -242,7 +489,7 @@
 def dec2bcd(dec):
     return chr(dec % 10 + (dec / 10) * 16)
 
-def dec2bin(n, trim=-1):
+def dec2bin(n, trim= -1):
     a = ""
     while n > 0:
         if n % 2 == 0:
@@ -253,7 +500,7 @@
 
     if trim != -1:
         if len(a) < trim:
-            a = ("0" * (trim-len(a))) + a
+            a = ("0" * (trim - len(a))) + a
     return a
 
 #
@@ -277,7 +524,7 @@
 
     def __init__(self, port, consts=None):
         self._consts = consts or MP25Constants
-        port.set_options(read_timeout=2, write_timeout=5)
+        port.set_options(read_timeout=3, write_timeout=5)
         SerialBase.__init__(self, port)
         # XXX: Seems that Bematech doesn't contains any variable with the
         # coupon remainder value, so I need to manage it by myself.
@@ -315,13 +562,28 @@
     def _read_reply(self, size):
         a = 0
         data = ''
+        ack = False
         while True:
             if a > RETRIES_BEFORE_TIMEOUT:
-                raise DriverError("Timeout")
+                raise DriverError("ECF Desconectada/Desligada ou Sem Papel")
 
             a += 1
-            reply = self.read(size)
-            if reply is None:
+            if not ack:
+                reply = self.read(1)
+            else: # caso retornou o ack mas esta demorando no retorno do resto do comando
+                reply = self.read(size-1) # tamanho menos o ACK
+
+            if not reply:
+                continue
+
+            if reply == chr(6): # ACK = comando foi executado na impressora
+                ack = True
+                data += reply
+                reply = self.read(size-1) # tamanho menos o ACK
+            elif reply == 21 or reply == chr(15): # NAK = erro na execução do comando ou timeout na recepcao dos dados pela impressora
+                raise DriverError("Erro na execução do comando/ECF Desligada ou Sem Papel")
+            elif not ack:  # o elemento lido nao eh ACK e nem NAC ou seja, deve ser lixo no buffer
+                a = 0
                 continue
 
             data += reply
@@ -336,6 +598,7 @@
         status.check_error()
 
     def _send_command(self, command, *args, **kwargs):
+        log.debug("_send_command(%r, %r %r')" % (command, args, kwargs))
         fmt = ''
         if 'response' in kwargs:
             fmt = kwargs.pop('response')
@@ -357,22 +620,41 @@
                 raise NotImplementedError(type(arg))
 
         data = self._create_packet(cmd)
+
         self.write(data)
 
         format = self.reply_format % fmt
-        reply = self._read_reply(struct.calcsize(format))
+        # Condição implementada abaixo é um tratamento p/ não prosseguir c/ retorno invalido da ecf.
+        # Aki é verificado se o primeiro bit é igual 06H e se o comando enviado pertencia a lista de
+        # comandos.
+        while True:
+            reply = self._read_reply(struct.calcsize(format))
+            if reply[0] != chr(6) and command in [29, 35]:
+                self.write(data)
+            else:
+                break
+        if command == 71:
+            return reply
         retval = struct.unpack(format, reply)
 
         if raw:
+            #self._check_error(retval)
             return retval
 
-        self._check_error(retval)
-
         response = retval[1:-self.status_size]
         if len(response) == 1:
             response = response[0]
         return response
 
+    def retorno_de_variaveis(self, var, tam):
+        retval = self._send_command(35, var, response='%ds' % tam)
+        return binascii.b2a_hex(retval)
+
+    def ler_ultima_reducao(self):
+        retval = self._send_command(62, 55, response='308s')
+        retval = binascii.b2a_hex(retval)
+        return retval
+
     def _read_register(self, reg):
         try:
             fmt, bcd = self.registers.formats[reg]
